searchNodes=[{"ref":"TelemetryMetricsPrometheus.html","title":"TelemetryMetricsPrometheus","type":"module","doc":"Prometheus Reporter for Telemetry.Metrics definitions. Provide a list of metric definitions to the init/2 function. It&#39;s recommended to run TelemetryMetricsPrometheus under a supervision tree, usually under Application. def start(_type, _args) do # List all child processes to be supervised children = [ {TelemetryMetricsPrometheus, [metrics: metrics()]} ... ] opts = [strategy: :one_for_one, name: ExampleApp.Supervisor] Supervisor.start_link(children, opts) end defp metrics, do: [ counter(&quot;http.request.count&quot;), sum(&quot;http.request.payload_size&quot;, unit: :byte), last_value(&quot;vm.memory.total&quot;, unit: :byte) ] By default, metrics are exposed on port 9568 at /metrics. The port number can be configured if necessary. You are not required to use the included server, though it is recommended. https is not supported yet, in which case the TelemetryMetricsPrometheus.Core library should be used instead. The TelemetryMetricsPrometheus.Core.scrape/1 function will expose the metrics in the Prometheus text format. Please see the TelemetryMetricsPrometheus.Core docs for information on metric types and units. Telemetry Events [:prometheus_metrics, :plug, :stop] - invoked at the end of every scrape. The measurement returned is :duration and the metadata is the conn map for the call. A suggested Distribution definition might look like: Metrics.distribution(&quot;prometheus_metrics.scrape.duration.milliseconds&quot;, buckets: [0.05, 0.1, 0.2, 0.5, 1], description: &quot;A histogram of the request duration for prometheus metrics scrape.&quot;, event_name: [:prometheus_metrics, :plug, :stop], measurement: :duration, tags: [:name], tag_values: fn %{conn: conn} -&gt; %{name: conn.private[:prometheus_metrics_name]} end, unit: {:native, :millisecond} )"},{"ref":"TelemetryMetricsPrometheus.html#child_spec/1","title":"TelemetryMetricsPrometheus.child_spec/1","type":"function","doc":"Reporter&#39;s child spec. This function allows you to start the reporter under a supervisor like this: children = [ {TelemetryMetricsPrometheus, options} ] See start_link/1 for a list of available options. Returns a child specification to supervise the process."},{"ref":"TelemetryMetricsPrometheus.html#start_link/1","title":"TelemetryMetricsPrometheus.start_link/1","type":"function","doc":"Starts a reporter and links it to the calling process. Available options: :metrics - a list of Telemetry.Metrics definitions to monitor. required :name - the name to set the process&#39;s id to. Defaults to :prometheus_metrics :port - port number for the reporter instance&#39;s server. Defaults to 9568 :protocol - http protocol scheme to use. Defaults to :http :plug_cowboy_opts - additional plug_cowboy options, such as ssl settings. See Plug.Cowboy for more information. Defaults to []. Setting the :port option here will be overriden by the root :port option. All other options are forwarded to TelemetryMetricsPrometheus.Core.init/2."},{"ref":"TelemetryMetricsPrometheus.html#t:option/0","title":"TelemetryMetricsPrometheus.option/0","type":"type","doc":""},{"ref":"TelemetryMetricsPrometheus.html#t:options/0","title":"TelemetryMetricsPrometheus.options/0","type":"type","doc":""},{"ref":"overview.html","title":"Overview","type":"extras","doc":"Overview TelemetryMetricsPrometheus is a Telemetry.Metrics Reporter for aggregating and exposing Prometheus metrics based on Telemetry.Metrics definitions. The reporter runs as a standalone application and provides its own web server. This makes it very simple to instrument your project, regardless of your project type! Let us know how you&#39;re using it."},{"ref":"overview.html#getting-started","title":"Overview - Getting Started","type":"extras","doc":"Once you have the package added to your dependencies, you can start TelemetryMetricsPrometheus by initiating the application during your application startup. def start(_type, _args) do # List all child processes to be supervised children = [ {TelemetryMetricsPrometheus, [metrics: metrics()]} ... ] opts = [strategy: :one_for_one, name: ExampleApp.Supervisor] Supervisor.start_link(children, opts) end defp metrics, do: [ counter(&quot;http.request.count&quot;), sum(&quot;http.request.payload_size&quot;, unit: :byte), last_value(&quot;vm.memory.total&quot;, unit: :byte) ] By default, metrics are exposed on port 9568 at /metrics. The port number can be configured if necessary. You are not required to use the included server, though it is recommended. https is not supported yet, in which case exposing a /metrics endpoint and calling the scrape/1 function is your best option until TLS is supported. Note that aggregations for distributions (histogram) only occur at scrape time. These aggregations only have to process events that have occurred since the last scrape, so it&#39;s recommended at this time to keep an eye on scrape durations if you&#39;re reporting a large number of disributions or you have a high tag cardinality."},{"ref":"overview.html#core-library","title":"Overview - Core library","type":"extras","doc":"Please see https://github.com/beam-telemetry/telemetry_metrics_prometheus_core/blob/master/docs/overview.md for documentation of the core that powers this library."},{"ref":"rationale.html","title":"Rationale","type":"extras","doc":"Rationale We love the :telemetry ecosystem and everything it has to offer for instrumentation of our applications! We also love Prometheus, but wiring up handlers is time consuming and we couldn&#39;t find an existing Prometheus library that met our needs and offered the :telemetry + Telemetry.Metrics integration that we wanted. This project aims to fit a very specific need: reporting of :telemetry events in Prometheus format via Telemetery.Metrics definitions. There is no aim to create a full Prometheus client library. We think this package provides the best way to collect metrics in Elixir for Prometheus, but if your needs are different, other existing works may be a better fit. Check out the BEAM OpenCensus project, especially if you need a solution for Erlang."},{"ref":"rationale.html#why-include-a-server","title":"Rationale - Why include a server?","type":"extras","doc":"It requires no modifications to your existing web server (assuming your app even has one!). It&#39;s much simpler to run a separate server versus adding a route and wiring up your scrape. Security. You don&#39;t have to lock down a route. You can keep the port the reporter is running on from being exposed to the outside world very simply with your infra configuration. Do you even web server, bruh? Maybe you&#39;re using Nerves! Maybe you want to instrument a background task. Whatever the case may be, we aim to make it easy to scrape via the included web server or push scrapes to a destination."}]